import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.awt.image.ImageFilter;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.MenuEvent;
import javax.swing.event.MenuListener;
import javax.swing.filechooser.FileNameExtensionFilter;

import uk.ac.leedsbeckett.oop.GraphicsPanel;

public class Mainclass   
{

	
	private JFrame frame;
	private static GraphicsPanel turtle;
	private JPanel commands;
	public JTextField input;
	private JLabel text;
	public JMenuBar menu ;
	public JMenu File , Help ;
	public JMenuItem New , Load , Save , Exit , About;
	private static  int HEIGHT=200;
	private static  int WIDTH=400;
	private JFileChooser FileChooser ;
	private BufferedImage  image;
	private int issue=0;
    private String[] commandsIssued = new String[issue];
    private  float thickness ;
    private int size;
    private int distance;
    private GUIinterface.Pen pen;
    
    
    public Mainclass()
	{ 
		components();
		
	}
   



	public  void components()
	{   
		 FileChooser=new JFileChooser();
		
		
	    frame = new JFrame("Nicolae Ciprian Mocanu");
	    frame.setMinimumSize(new Dimension(WIDTH , HEIGHT));
	   // frame.setMaximumSize(new Dimension(600 , 300));
	    frame.setResizable(true);
	    frame.setSize(400,200);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		
		
		turtle = new GraphicsPanel();
		turtle.setSize(300,200);
		turtle.getCommandsIssued();
		turtle.penDown();
		frame.getContentPane().add(turtle);
		frame.add(turtle , BorderLayout.NORTH);
		 
		
		
		
		commands = new JPanel();
		commands.setSize(100,100);
		frame.getContentPane().add(commands);
		frame.add(commands , BorderLayout.SOUTH);
		
		
		
		menu = new JMenuBar();
		
		
		 File = new JMenu("File");
		menu.add(File);
		File.addMenuListener(new myMenuListener());
		
		 Help = new JMenu("Help");
		menu.add(Help);
		Help.addMenuListener(new myMenuListener());
		
		frame.setJMenuBar(menu);
		
		 New =  new JMenuItem("New");
		File.add(New);
		New.addActionListener(new myActionListener());
		
		 Load = new JMenuItem("Load");
		File.add(Load);
		Load.addActionListener(new myActionListener());
		
		 Save = new JMenuItem("Save");
		File.add(Save);
		Save.addActionListener(new myActionListener());
		
		
		 Exit = new JMenuItem("Exit");
		File.add(Exit);
		Exit.addActionListener(new myActionListener());
		
		 About = new JMenuItem("About");
		Help.add(About);
		About.addActionListener(new myActionListener());
		
		
		text = new JLabel("Please type a command ==>");
		commands.add(text);
		
		input =new JTextField(10);
		input.addActionListener(new myInputListener());
		commands.add(input);
		
	   
		
			

		turtle.about();
		
		frame.pack();
		

		
		frame.setVisible(true);
		
	
	}



	public class myMenuListener implements MenuListener
	
	{
		JFrame f = new JFrame();
		@Override
		public void menuCanceled(MenuEvent e) {
			
			
		}

		@Override
		public void menuDeselected(MenuEvent e) {
			
			
		}

		@Override
		public void menuSelected(MenuEvent e) {
			if(e.getSource()==File)
				
			{
				
				JOptionPane.showMessageDialog(f, "File has been selected" , "confirmation" ,JOptionPane.INFORMATION_MESSAGE );
			}
			
			else if (e.getSource()==Help)
				
			{
				
				JOptionPane.showMessageDialog(f, "Help has been selected" , "confirmation" ,JOptionPane.INFORMATION_MESSAGE );
			}
		}
		
	}
	
	
	
	public  class myActionListener implements ActionListener
	{
		
		@Override
		public void actionPerformed(ActionEvent e) 
		{
			
			JFrame f = new JFrame();
			 
			if(e.getSource()==New)
			{
				
				JOptionPane.showMessageDialog(f, "New has been selected" , "confirmation" ,JOptionPane.INFORMATION_MESSAGE );
				turtle.clear();
			}
			
			
			else if(e.getSource()==Load)
			{
				JOptionPane.showMessageDialog(f, "Load has been selected" , "Confirmation" ,JOptionPane.INFORMATION_MESSAGE );
				JOptionPane.showMessageDialog(f, "You haven't saved the file" , "Warning" ,JOptionPane.YES_NO_OPTION );
				int returnValue = FileChooser.showSaveDialog(f);
				
				
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					
					BufferedImage image =turtle.getImage();
					
			try{	 
				 ImageIO.write(image, "jpg", FileChooser.getSelectedFile());
			}
			catch(IOException ex)
			{	 
				}
			JOptionPane.showMessageDialog(f, "The image has been saved" ,"confirmation" , JOptionPane.INFORMATION_MESSAGE );
				}
				 
				
				
				if(returnValue == JFileChooser.CANCEL_OPTION)
				{
					 returnValue = FileChooser.showOpenDialog(f);
				}
				
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					JOptionPane.showMessageDialog(f, "File has been loaded" ,"confirmation" , JOptionPane.INFORMATION_MESSAGE );
					try {
					BufferedImage image = ImageIO.read(FileChooser.getSelectedFile());
					turtle.setImage(image);
					}
					catch(IOException ex)
					{	 
						}
					
				}
				
				
			}
			
			
			else if(e.getSource()==Save)
			{ 
				JOptionPane.showMessageDialog(f, "Save has been selected" , "confirmation" ,JOptionPane.INFORMATION_MESSAGE );
				
				FileChooser.setCurrentDirectory(new File("C:\\temp"));
			FileChooser.setFileFilter(new FileNameExtensionFilter("JPG image" , "jpg"));
			
				int returnValue = FileChooser.showSaveDialog(f);
				
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					
					BufferedImage image =turtle.getImage();
					
			try{	 
				 ImageIO.write(image, "jpg", FileChooser.getSelectedFile());
			}
			catch(IOException ex)
			{	 
				}
			JOptionPane.showMessageDialog(f, "The image has been saved" ,"confirmation" , JOptionPane.INFORMATION_MESSAGE );
				}
				 
			}
				
			
			else if(e.getSource()==Exit)
			{
				 JOptionPane.showMessageDialog(f, "Exit has been selected" , "Confirmation" ,JOptionPane.INFORMATION_MESSAGE );
				 JOptionPane.showMessageDialog(f, "You haven't saved the file" ,"Warning" , JOptionPane.YES_NO_OPTION);
				 
				 int returnValue = FileChooser.showSaveDialog(f);
				 if(returnValue == JFileChooser.APPROVE_OPTION)
				 {
					
					 BufferedImage image =turtle.getImage();
						
						try{	 
							 ImageIO.write(image, "jpg", FileChooser.getSelectedFile());
						}
						catch(IOException ex)
						{	 
							}
						JOptionPane.showMessageDialog(f, "The image has been saved" ,"Confirmation" , JOptionPane.INFORMATION_MESSAGE );
				 }
		               
			
		                if (returnValue == JFileChooser.CANCEL_OPTION) 
		               {
		                	
		            	   System.exit(0);  
		               }
				 
			
				 
		}
			
			else if(e.getSource()==About)
			{
				
				 JOptionPane.showMessageDialog(f, "About has been selected" , "Confirmation" ,JOptionPane.INFORMATION_MESSAGE );
				 JOptionPane.showMessageDialog(f, "Hello ... How can I help you ? " , "Question" ,JOptionPane.QUESTION_MESSAGE );
			}
			
			
		}
		
	}
	

	public class myInputListener implements ActionListener 
	{
		
		private static final int TYPE_GENERAL_ROTATION = 60;
		private int width=6;
		private Object thickness;

		@Override
		public void actionPerformed(ActionEvent e) {
			System.out.println(input.getText());
			
			if (input.getText().toLowerCase().equals("exit")) {
				
				System.exit(0);
			}
			
			else if (input.getText().toLowerCase().equals("clear"))
					{
				
				turtle.clear();
				
			}
			
			else if (input.getText().toLowerCase().equals("about"))
			{
				
		turtle.about();
		
	}
			
			else if (input.getText().toLowerCase().startsWith("forward")) {
				
				
				try {
					
					int distance = Integer.parseInt(input.getText().split(" ")[1]);
					turtle.forward(distance);
				}
				
			
			
			catch (NumberFormatException error) {
				JOptionPane.showMessageDialog(null, "Invalid parameter" , "Warning" ,JOptionPane.ERROR_MESSAGE );
			}
				
				catch(ArrayIndexOutOfBoundsException error) {
					JOptionPane.showMessageDialog(null, "Missing parameter" , "Warning" ,JOptionPane.ERROR_MESSAGE );	
				}
			
			
			}
			
			else if (input.getText().toLowerCase().startsWith("backward")) {
				
				
				try {
					
				int distance = Integer.parseInt(input.getText().split(" ")[1]);
				turtle.turnRight();
				turtle.turnRight();
				turtle.forward(distance);
				}
				catch(NumberFormatException error) {
					JOptionPane.showMessageDialog(null, "Invalid parameter" , "Warning" ,JOptionPane.ERROR_MESSAGE );	
				}
				
				catch(ArrayIndexOutOfBoundsException error) {
					JOptionPane.showMessageDialog(null, "Missing parameter" , "Warning" ,JOptionPane.ERROR_MESSAGE );	
				}
				
				
				}
		
			else if (input.getText().toLowerCase().equals("thickness")) {
				try {
				//	int width=6;
				//	width=6;
				//	pen.thickness1(this.thickness);
					//repaint();
				ExtendedGraphicsPanel();
				}
				catch(NullPointerException error)
				
				{
					JOptionPane.showMessageDialog(null , "error");
				}
			}
			
			else if (input.getText().toLowerCase().startsWith("triangle"))
					{
					distance=size/3;
					
					
					int direction=60;
					turnLeft(direction);
					turtle.forward(distance);
					turtle.setDirection(TYPE_GENERAL_ROTATION);
					turtle.forward(distance);
					turtle.setDirection(TYPE_GENERAL_ROTATION);
					turtle.forward(distance);
				
				
					}
			
			
			else if (input.getText().toLowerCase().equals("turnright")) {
				
			
				turtle.turnRight();
			
			}
			
			else if (input.getText().equals("turnleft")) 
			{
			
				turtle.turnLeft();
			}
			
		
			
			else if (input.getText().toLowerCase().equals("penup"))
			{
				
				
				turtle.penUp();
			}
			
			else if (input.getText().toLowerCase().equals("pendown"))
			{
				
				
				turtle.penDown();
			}
			
			else if (input.getText().toLowerCase().equals("red"))
			{
				
				
			turtle.setPenColour(Color.red);
			
			}
			
			else if (input.getText().toLowerCase().equals("black"))
			{
				
				
			turtle.setPenColour(Color.black);
			
			}
			

			else if (input.getText().toLowerCase().equals("green"))
			{
			
			
			turtle.setPenColour(Color.green);
			
			}
			

			else if (input.getText().toLowerCase().equals("yellow"))
			{
				
			turtle.setPenColour(Color.yellow);
			
			}
			
			else if (input.getText().toLowerCase().equals("blue"))
			{
				
			
			turtle.setPenColour(Color.blue);
			
			}
			else if (input.getText().toLowerCase().equals("pink"))
			{
				
				
			turtle.setPenColour(Color.pink);
			
			}
			
			else if (input.getText().toLowerCase().equals("reset"))
			{
				
				
			turtle.about();
			
			}
			else if (input.getText().toLowerCase().equals(""))   
			{
				
				
				JOptionPane.showMessageDialog (null, "Missing parameter" , "Warning",JOptionPane.ERROR_MESSAGE);	
			}
			
			else
				
			{
				
				
				JOptionPane.showMessageDialog (null, "Invalid parameter" , "Warning",JOptionPane.ERROR_MESSAGE);	
			}
			
			input.setText("");
			
			
			
		}
	
		private void ExtendedGraphicsPanel() {
			// TODO Auto-generated method stub
			ExtendedGraphicsPanel Object= new ExtendedGraphicsPanel(); 
		}

		private void turnLeft(int direction) {
			// TODO Auto-generated method stub
			
		}
		public void thickness(Object thickness) {
			// TODO Auto-generated method stub
			//public void setPen(float thickness) {
				this.thickness = thickness;
			
			}
	
	}
	
	public static void main(String[] args) {
		
		
		Mainclass obj=new Mainclass();
		
		
	}



	}

		